/**
 * NOTE: This class is auto generated by the swagger code generator program (2.4.0-SNAPSHOT).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package com.sidlors.lab.microservice.pet.api;

import java.util.ArrayList;
import java.util.Optional;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.sidlors.lab.microservice.pet.model.Pet;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;
@javax.annotation.Generated(value = "io.swagger.codegen.languages.SpringCodegen", date = "2019-06-21T19:35:07.921Z")

@Api(value = "pet", description = "the pet API")
public interface PetApi {

    Logger log = LoggerFactory.getLogger(PetApi.class);

    public Optional<ObjectMapper> getObjectMapper();

    public Optional<HttpServletRequest> getRequest();

    public Optional<String> getAcceptHeader();

    @ApiOperation(value = "Add a new pet to the store", nickname = "addPet", notes = "", response = Pet.class, tags={ "pet", })        
    @ApiResponses(value = { 
    		@ApiResponse(code = 400, message = "Invalid ID supplied"),
            @ApiResponse(code = 404, message = "Pet not found"),
        	@ApiResponse(code = 200, message = "Successful operation", response = Pet.class)
        })
    @RequestMapping(value = "/pet",
        produces = { "application/json", "application/xml" }, 
        method = RequestMethod.POST)
    public ResponseEntity<Pet> addPet(@ApiParam(value = "Pet object that needs to be added to the store" ,required=true )  @Valid @RequestBody Pet body);

    
    @ApiOperation(value = "Find pet by ID", nickname = "getPetById", notes = "Returns a single pet", response = Pet.class, tags={ "pet", })
    @ApiResponses(value = { 
            @ApiResponse(code = 200, message = "successful operation", response = Pet.class),
            @ApiResponse(code = 400, message = "Invalid ID supplied"),
            @ApiResponse(code = 404, message = "Pet not found") })
    @RequestMapping(value = "/pet/{petId}",
    	produces = { "application/json", "application/xml" }, 
    	method = RequestMethod.GET)
    public ResponseEntity<Pet> getPetById(@ApiParam(value = "ID of pet to return",required=true) @PathVariable("petId") Long petId);
    
    
    @ApiOperation(value = "Find all pets", nickname = "getPetAll", notes = "Returns a list pets", response = Pet.class, tags={ "pets", })
    @ApiResponses(value = { 
            @ApiResponse(code = 200, message = "successful operation", response = Pet.class),
            @ApiResponse(code = 400, message = "Invalid ID supplied"),
            @ApiResponse(code = 404, message = "Pet not found") })
    @RequestMapping(value = "/pet",
    	produces = { "application/json", "application/xml" }, 
    	method = RequestMethod.GET)
    public ResponseEntity<ArrayList<Pet>> getPetAll() throws ApiException;
        
    
    @ApiOperation(value = "Deletes a pet", nickname = "deletePet", notes = "", tags={ "pet", })
    @ApiResponses(value = { 
    	@ApiResponse(code = 400, message = "Invalid ID supplied"),
        @ApiResponse(code = 404, message = "Pet not found") })
    	@ApiResponse(code = 200, message = "Successful operation", response = Pet.class)
    @RequestMapping(value = "/pet/{petId}",
    	produces = { "application/json", "application/xml" }, 
        method = RequestMethod.DELETE)
    public ResponseEntity<Pet> deletePet(@ApiParam(value = "Pet id to delete",required=true) @PathVariable("petId") Long petId);
    
    
    @ApiOperation(value = "Update pet", nickname = "updatePet", notes = "", response = Pet.class, tags={ "pet", })        
    @ApiResponses(value = { 
    		@ApiResponse(code = 400, message = "Invalid ID supplied"),
            @ApiResponse(code = 404, message = "Pet not found"),
        	@ApiResponse(code = 200, message = "Successful operation", response = Pet.class)
        })
    @RequestMapping(value = "/pet/update",
        produces = { "application/json", "application/xml" }, 
        method = RequestMethod.POST)
    public ResponseEntity<Pet> updatePet(@ApiParam(value = "Pet object that needs to be update to the store" ,required=true )  @Valid @RequestBody Pet body);
    

}
